package sgc.portal.base.exception.advice;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;

/**
 * <pre>
 * 예외가 발생할 경우 예외 내용을 체계적으로 담고
 * End-User에게 출력한다.
 * </pre>
 *
 * @author YongSang
 * @version 1.0.0
 * @since 2020. 7. 28.
 */
@Data
public class ErrorMessage {
    private int errorCode;
    private Object[] args;
    private String messageCode;
    private String message;

    /**
     * 사용자 정의 코드/명
     */
    private String busiErrorCode;
    private String busiMessage;

    @JsonIgnore
    private Throwable cause;
}