package sgc.portal.base.persistence;

import sgc.portal.base.model.SmComHelp;
import sgc.portal.base.util.EasyHashMap;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;


/**
 * 프로그램 목록 매퍼  DAO
 *
 * @author mir(khjang @ sgc.co.kr)
 * @version 1.0.0
 * @since 2020. 8. 2.
 */
@Mapper
public interface ComHelpDeskMapper {
    /**
     * Select helpdesk list.
     *
     * @param smComHelp the sm com help
     * @return the list
     */
//공통내역코드 정보 조회
    List<EasyHashMap<String, Object>> selectHelpdesk(SmComHelp smComHelp);

    /**
     * Insert com help desk int.
     *
     * @param smComHelp the sm com help
     */
    void insertComHelpDesk(SmComHelp smComHelp);

    /**
     * Update com help desk int.
     *
     * @param smComHelp the sm com help
     */
    void updateComHelpDesk(SmComHelp smComHelp);

    /**
     * Gets status.
     *
     * @param smComHelp the sm com help
     * @return the status
     */
    int getStatus(SmComHelp smComHelp);
}

