
package sgc.portal.base.persistence;

//import kr.co.sgc.bo.hr.yta.calc.model.HrYtaMdcs;
import sgc.portal.base.model.ParticularsOfAccountPop;
import sgc.portal.base.util.EasyHashMap;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

/**
 * 콤보박스(부서) 매퍼 서비스.
 *
 * @author beomgeun.lee
* @version 1.0.0
 * @since 2020. 9. 22.
 */
@Mapper
public interface ComParticularsOfAccountPopMapper {

    /**
     * Select particulars of account popup easy hash map.
     *
     * @param particularsOfAccountPop the particulars of account pop
     * @return the easy hash map
     */
    EasyHashMap<String, Object> selectParticularsOfAccountPopup(ParticularsOfAccountPop particularsOfAccountPop);

    /**
     * Select particulars of account popup list list.
     *
     * @param particularsOfAccountPop the particulars of account pop
     * @return the list
     */
    List<EasyHashMap<String, Object>> selectParticularsOfAccountPopupList(@RequestBody ParticularsOfAccountPop particularsOfAccountPop);

    /**
     * Save particulars of account popup insert.
     *
     * @param particularsOfAccountPop the particulars of account pop
     */
    void saveParticularsOfAccountPopupInsert(ParticularsOfAccountPop particularsOfAccountPop);

    /**
     * Save particulars of account popup update.
     *
     * @param particularsOfAccountPop the particulars of account pop
     */
    void saveParticularsOfAccountPopupUpdate(ParticularsOfAccountPop particularsOfAccountPop);

    /**
     * Save particulars of account popup delete.
     *
     * @param particularsOfAccountPop the particulars of account pop
     */
    void saveParticularsOfAccountPopupDelete(ParticularsOfAccountPop particularsOfAccountPop);


//    /**
//     * Save hr yta mdcs delete.
//     *
//     * @param hrYtaMdcs the hr yta mdcs
//     */
//    void saveHrYtaMdcsDelete(HrYtaMdcs hrYtaMdcs);
//
//    /**
//     * Save hr yta mdcs insert.
//     *
//     * @param hrYtaMdcs the hr yta mdcs
//     */
//    void saveHrYtaMdcsInsert(HrYtaMdcs hrYtaMdcs);



}