package sgc.portal.base.service;

import sgc.portal.base.model.CommCd;
import sgc.portal.base.persistence.CommCdSelectMapper;
import sgc.portal.base.util.EasyHashMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * The type Comm cd select service.
 *
 * @author beomgeun.lee
* @version 1.0.0
 * @since 2020. 7. 5.
 */
@Transactional
@Service

public class CommCdSelectService {

    @Autowired
    private CommCdSelectMapper commCdSelectMapper;

    /**
     * Select comm cd list.
     *
     * @param commCd the comm cd
     * @return the list
     */
    public  List<EasyHashMap<String, Object>>  selectCommCd(CommCd commCd)
    {
        return commCdSelectMapper.selectCommCdList(commCd);

    }
}