package sgc.portal.base.storage;

import java.util.List;

/**
 * 첨부 파일들은 다양한 디렉토리 체계를 갖을 수 있다.
 * 특정한 디렉토리 체계를 갖는 클래스를 생성하려면 해당 인터페이스를 구현한다.
 *
 * @author YongSang
 * @version 1.0.0
 * @since 2020. 9. 5.
 */
public interface Subpath {
    /**
     * Resolve list.
     *
     * @return the list
     */
    List<String> resolve();
}