package sgc.portal.base.storage.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import sgc.portal.base.Domain;
import lombok.Data;

/**
 * 파일 업로드 모델클래스
 *
 * @author YongSang
 * @version 1.0.0
 * @since  2020. 9. 5.
 */
@Data
public class FileBucket extends Domain {
    private String id; // 파일아이디
    private Integer backNumber; // 파일번호
    private String originalFilename; // 원본파일명
    @JsonIgnore
    private String changedFilename; // 변경된 파일명
    @JsonIgnore
    private String location; // 파일위치
    private Long fileSize = 0L; // 파일사이즈
    private String deleted = "N"; // 삭제여부
    
    /**
     * 이미지 썸네일
     */
    private ImageThumbnail thumbnail;
}