package sgc.portal.base.web;

import sgc.portal.base.model.CommCd;
import sgc.portal.base.service.CommCdSelectService;
import sgc.portal.base.util.EasyHashMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;


/**********************************************************
 * 시스템명  : 시스템관리(COM) - 공통코드
 * 프로그램ID : CommCdSelectController
 * 프로그램명   : 팝업화면 Controller
 * @author  : mir(aaaa@aaa.co.kr)
 * @version  :  2020-09-11
 * @since JDK1.8
 * @see   1.최초 작성
 */
@RestController
public class CommCdSelectController {

    @Autowired

    private CommCdSelectService commCdSelectService;

    /**
     * Comm cd select list.
     *
     * @param commcds the commcds
     * @return list
     * @throws Exception
     */
//공통내역 코드정보 조회
    @PostMapping(value = "/com/cmm/commCdSelect")
    public List<EasyHashMap<String, Object>> commCdSelect(@RequestBody CommCd commcds) {
        return commCdSelectService.selectCommCd(commcds);
    }

}
