package sgc.portal.com.auth.persistence;

import sgc.portal.com.auth.model.PrvtinfoFindHist;
import sgc.portal.base.util.EasyHashMap;
import org.apache.ibatis.annotations.Mapper;
import sgc.portal.com.auth.service.MaskingDesabledService;
import sgc.portal.com.auth.web.MaskingDesabledController;

import java.util.List;

/**
 * <pre>
 * 시스템명   : Common
 * 프로그램ID : PrvtInfoFindHistMapper
 * 프로그램명  : 개인정보 이력 누적 mapper
 * 설명 : 개인정보 조회 정보에 대해서 DB 처리 한다.
 * </pre>
 *
 * @author 이범근
 * @version 2020.01.13
 * @see MaskingDesabledController
 * @see MaskingDesabledService
 * @see PrvtinfoFindHist
 * @since JDK1.8
 */
@Mapper
public interface PrvtInfoFindHistMapper {

    /**
     * Select prvt info desabled yn string.
     *
     * @param prvtinfoFindHist the prvtinfo find hist
     * @return the string
     */
    String selectPrvtInfoDesabledYn(PrvtinfoFindHist prvtinfoFindHist);

    /**
     * 개인정보 조회 이력 누적
     *
     * @param prvtinfoFindHist the prvtinfo find hist
     */
    void insertPrvtinfoFindHist(PrvtinfoFindHist prvtinfoFindHist);

    /**
     * 개인 정보 조회 이력
     *
     * @param prvtinfoFindHist 기본 모델 제공
     * @return 개인 정보 조회 이력 목록
     */
    List<EasyHashMap<String, Object>>selectPrvtinfoFindHist(PrvtinfoFindHist prvtinfoFindHist);

}
