package sgc.portal.com.com.model;

import sgc.portal.base.Domain;

import lombok.Data;

/*
 * 모든 모델 객체는 Domain class를 상속 받도록 합니다.
 * Domain 객체에는 wrteDt, wrtePr, mdftDt, mdftPr 등과 같은
 * 반복적으로 사용되는 변수들이 선언되어있어 상속만 받으면 위 변수들을 선언할 필요가 없습니다.
 * 또한 자동으로 로그인 사용자의 아이디가 assign됩니다.
 * 더불어 rowStatus, chk 같이 여러 곳에서 반복적으로 사용될 수 있는 변수들을
 * Domain 객체에 미리 선언하고 사용하는 것도 좋은 방법입니다.
 *  2020.08.31 yongsang
 */
@Data
public class User extends Domain {
	private String cmpnCd;
    private String userId;
    private String lginId;
    private String scrtNo;
    private String userNm;
    private String userNmEngs;
    private String emlAddr;
    private String tpnNo;
    private String hpNo;
    private String useValdDt;
    private String pswdEddt;
    private String empNo;
    private String grpwareId;
    private String bsuCd;
    private String bsuNm;
    private String deptCd;
    private String deptNm;
    private String exptUserDcd;
    private String pwInit;
    private String pswdFailDt;
    private String pswdFailCnt;

    private String bsiteCd;
    private String bsiteNm;
    private String psnlinfo;
    /*
     * Domain 객체에 이미 정의되어 있으므로 주석처리 합니다.
     * 향후 삭제 부탁 드립니다.
     *  2020.08.31 yongsang
     */
//    private String wrteDt;
//    private String wrtePr;
//    private String mdftDt;
//    private String mdftPr;
    /*private String chk;*/
    private String rowStatus;
    private String wkwebUseyn;
    private String gruprsrtYn;
    private String cmsUseyn;
    
    
    private String logpass;

}