/*
 * Copyright 2011- 2020 SDCIT Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package sgc.portal.com.sym.batch.persistence;

import sgc.portal.base.util.EasyHashMap;
import sgc.portal.com.sym.batch.model.Batch;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 로그인 매퍼 서비스.
 *
 * @author SDCIT
 * @version 1.0.0
 * @since 2020. 7. 5.
 */
@Mapper
public interface BatchMapper {
    
	List<EasyHashMap<String, Object>> getList();
	List<EasyHashMap<String, Object>> getMngEmail(String empNo);
	int insertSms(Batch batch);
	
	List<EasyHashMap<String, Object>> getList2();
	int updatePass(Batch batch);
	
	List<EasyHashMap<String, Object>> getList3(String frDate);
	List<EasyHashMap<String, Object>> getMhList3(@Param("empNo")String empNo, @Param("frDate")String frDate);
	
	List<EasyHashMap<String, Object>> getList4(String frDate);
	List<EasyHashMap<String, Object>> getMhList4(@Param("empNo")String empNo, @Param("frDate")String frDate);
	
	List<EasyHashMap<String, Object>> getList5(String frDate);
	List<EasyHashMap<String, Object>> getList6(String frDate);
	List<EasyHashMap<String, Object>> getMhEmail();

	List<EasyHashMap<String, Object>> getList7(String frDate);
	List<EasyHashMap<String, Object>> getMhList7(@Param("empNo")String empNo, @Param("frDate")String frDate);
   
}