/**
 * @(#)file    SmtpAuth.java
 * @(#)author  Kim Sun-Youp
 * @(#)version 1.0
 * @(#)date    2007-07-23
 * 
 * Javamail 을 이용하면서 STMP 프로토콜에 인증 방식을 사용할 경우
 * Authenticator 클래스를 상속 받아서 getPasswordAuthentication()
 * 메소드를 오버라이드 시킵니다.
 * 
 * Copyright (c) 2002-2003 www.udapsoft.co.kr, Inc.
 * All rights reserved.
 * This software is the proprietary information of udapsoft, Inc.
 */
package sgc.portal.com.sym.mail.model;

import javax.mail.Authenticator;

/**
 * @author 김선엽
 * SMTP 연결시 인증을 요구하는 서버라면 아래의 클래스를 임포트하여야 합니다.
 * SmtpAuth auth = new SmtpAuth("아이디", "비밀번호");
 * @see kr.co.sky72.source.ord.OrderSendWorkerSave
 */
public class SmtpAuth extends Authenticator {
	private String id;
	private String pw;
	
	public SmtpAuth(String id, String pw) {
		this.id = id;
		this.pw = pw;
	}
	
	protected javax.mail.PasswordAuthentication getPasswordAuthentication() {
		return new javax.mail.PasswordAuthentication(id, pw);
	}
}
