package sgc.portal.com.sym.user.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import sgc.portal.base.util.EasyHashMap;
import sgc.portal.com.sym.user.model.PgPayErrorSearch;
import sgc.portal.com.sym.user.persistence.PgPayErrorMapper;
import sgc.portal.com.sym.user.web.PgPayErrorController;

/**
 * <pre>
 * 시스템명    : 통합시스템(SYS)
 * 프로그램ID  : PgPayErrorService.java
 * 설명        : PG 결제 오류 목록을 조회 한다.
 *
 * </pre>
 *
 * @author 민경삼
 * @version 2020. 06. 22
 * @see PgPayErrorSearch
 * @see PgPayErrorController
 * @see sgc.portal.com.sym.user.persistence.PgPayErrorMapper
 * @since JDK1.8
 */
@Service
@Transactional
public class PgPayErrorService {

    @Autowired
    private PgPayErrorMapper PgPayErrorMapper;

    public List<EasyHashMap<String, Object>> selectPgPayErrorList(PgPayErrorSearch pgSearch) {
        return PgPayErrorMapper.selectPgPayErrorList(pgSearch);
    }
}