package sgc.portal.com.sym.user.web;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import sgc.portal.base.util.EasyHashMap;
import sgc.portal.com.sym.user.model.PgPayErrorSearch;
import sgc.portal.com.sym.user.service.PgPayErrorService;


/**
 * <pre>
 * 시스템명    : 통합시스템(SYS)
 * 프로그램ID  : PgPayErrorController.java
 * 설명        : PG 결제 오류 목록을 조회 한다.
 *
 * </pre>
 *
 * @author 민경삼
 * @version 2020. 06. 22
 * @see PgPayErrorSearch
 * @see PgPayErrorService
 * @since JDK1.8
 */
@RestController
public class PgPayErrorController {

    @Autowired
    private PgPayErrorService pgPayErrorService;

    @RequestMapping(value = "/sym/user/selectPgPayErrorList")
    public List<EasyHashMap<String, Object>> selectPgPayErrorList(@RequestBody PgPayErrorSearch pgSearch) {
        return pgPayErrorService.selectPgPayErrorList(pgSearch);
    }
}
