package sgc.portal.cs.cspop.dto;

import lombok.Getter;
import lombok.Setter;
import sgc.portal.base.BaseSearchDto;

@Getter
@Setter
public class CSPOPSearch extends BaseSearchDto {
    /*
     * JSON Serialize, Deserialize 는 sgc.portal.base.format 패키지에 있는
     * 객체들을 사용하여 동작한다.
     * 기본 포멧은 Date -> yyyyMMdd, DateTime -> yyyyMMddHHmmss 이므로
     * Front, Back 모두 포멧에 맞춰 요청과 응답을 해야한다.
     * sgc.portal.base.util.DateTime 클래스는 Date 를 상속받은 클래스로
     * 단순히 시간까지 표현해야하는지 여부를 판단하기 위한 클래스로 시간까지 표현해야하는 경우
     * sgc.portal.base.util.DateTime 클래스를 사용하도록 한다.
     */
	
	/*
	 * 하자현장팝업 
	 * csSitePop.xml
	 */
	private String mngHqtCd;	/*본부구분*/
	private String siteMngGbCd;	/*관리구분*/
	private String prodNo;		/*상품분류*/
	private String siteCd;		/*현장코드*/
	private String siteNm;		/*현장명*/
	private String vendNm;		/*계약현장명*/
	
	/*
	 * SMS전송팝업 
	 * csSmsPopM.xml
	 */
	private String deftNo;		/*하자번호*/
	
	private String empNo;		/*사번*/
	
	private String sitePrgsGbCd;
	private String probNo;
	private String corpKor;
	private String jobGbCd;
	private String contNm;
	private String elecGuarYn;
	private String jobtypItemNm;
	private String covendId;
	private String covendStatusGbCd;
	private String guarIntuNm;
	private String contSeq;
	private String chargeSeq;
}
