package sgc.portal.mobile.model;

import lombok.Getter;
import lombok.Setter;

/**
 * Manifest Json - Icon
 * 
 * @author 5364
 * @since 2022-09-19
 *
 */
@Getter
@Setter
public class ManifestIconVo {

	/**
	 * A string containing space-separated image dimensions using the same syntax as
	 * the sizes attribute.
	 */
	private String sizes;

	/**
	 * The path to the image file. If src is a relative URL, the base URL will be
	 * the URL of the manifest.
	 */
	private String src;

	/**
	 * A hint as to the media type of the image. The purpose of this member is to
	 * allow a user agent to quickly ignore images with media types it does not
	 * support.
	 */
	private String type;

    /**
     * Defines the purpose of the image, for example if the image is intended to
     * serve some special purpose in the context of the host OS (i.e., for better
     * integration).
     * 
     * monochrome: A user agent can present this icon where a monochrome icon with a
     * solid fill is needed. The color information in the icon is discarded and only
     * the alpha data is used. The icon can then be used by the user agent like a
     * mask over any solid fill.
     * 
     * maskable: The image is designed with icon masks and safe zone in mind, such
     * that any part of the image outside the safe zone can safely be ignored and
     * masked away by the user agent.
     * 
     * any: The user agent is free to display the icon in any context (this is the
     * default value).
     */
    private String purpose;
	
}
