package sgc.portal.mobile.model;

import java.util.List;

import lombok.Getter;
import lombok.Setter;

/**
 * Manifest Json - Short cut
 * 
 * @author 5364
 * @since 2022-09-19
 *
 */
@Getter
@Setter
public class ManifestShortcutVo {

	/**
	 * A string that can be displayed to the user in a context menu.
	 */
	private String name;

	/**
	 * A string that can be displayed where there is insufficient space to display
	 * the full name of the shortcut.
	 */
	private String short_name;

	/**
	 * A string that describes the purpose of the shortcut. It may be exposed to
	 * assistive technology.
	 */
	private String description;

	/**
	 * A URL within the application that opens when the shortcut is activated.
	 */
	private String url;

	/**
	 * A set of icons that represent the shortcut. They can be used, e.g., in the
	 * context menu. When included, the icon set must include a 96x96 pixel icon.
	 */
	private List<ManifestIconVo> icons;

}
