
package sgc.portal.security.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * 실행되는 메서드의 보안정책을 적용
 *
 * @author YongSang
 * @version 1.0.0
 * @since  2020. 7. 28.
 */
@Retention(value = RetentionPolicy.RUNTIME)
@Target({ElementType.TYPE, ElementType.METHOD})
public @interface Secured {
    SecurityPolicy policy() default SecurityPolicy.SESSION;
}