package sgc.portal.security.annotation;

/**
 * 실행되는 메소드가 어떤 보안 정책을 갖는지 표현한다.
 *
 * @author YongSang
 * @version 1.0.0
 * @since  2020. 7. 28.
 */
public enum SecurityPolicy {
    /**
     * 접근한 리소스에 대한 정상적인 접근 유무를 판단하는 정책 적용(CSRF 포함 등)
     */
    PROTECTED,

    /**
     * 접근한 리소스에 로그인 사용자가 접근할 수 있는 정책 적용
     */
    SESSION,
    
    /**
     * 보안 검사를 수행하지 않도록 정책 적용
     */
    NONE
}