/**
 * http://graphemica.com
 * http://blog.naver.com/bestdev/10014915998
 * http://ssaemo.tistory.com/28
 * https://github.com/lazygyu/CP949-to-Unicode-converter
 */
var hexTable = {};

hexTable.ksc5601 = {
    'AC00': 'B0A1',
    'AC01': 'B0A2',
    'AC04': 'B0A3',
    'AC07': 'B0A4',
    'AC08': 'B0A5',
    'AC09': 'B0A6',
    'AC0A': 'B0A7',
    'AC10': 'B0A8',
    'AC11': 'B0A9',
    'AC12': 'B0AA',
    'AC13': 'B0AB',
    'AC14': 'B0AC',
    'AC15': 'B0AD',
    'AC16': 'B0AE',
    'AC17': 'B0AF',
    'AC19': 'B0B0',
    'AC1A': 'B0B1',
    'AC1B': 'B0B2',
    'AC1C': 'B0B3',
    'AC1D': 'B0B4',
    'AC20': 'B0B5',
    'AC24': 'B0B6',
    'AC2C': 'B0B7',
    'AC2D': 'B0B8',
    'AC2F': 'B0B9',
    'AC30': 'B0BA',
    'AC31': 'B0BB',
    'AC38': 'B0BC',
    'AC39': 'B0BD',
    'AC3C': 'B0BE',
    'AC40': 'B0BF',
    'AC4B': 'B0C0',
    'AC4D': 'B0C1',
    'AC54': 'B0C2',
    'AC58': 'B0C3',
    'AC5C': 'B0C4',
    'AC70': 'B0C5',
    'AC71': 'B0C6',
    'AC74': 'B0C7',
    'AC77': 'B0C8',
    'AC78': 'B0C9',
    'AC7A': 'B0CA',
    'AC80': 'B0CB',
    'AC81': 'B0CC',
    'AC83': 'B0CD',
    'AC84': 'B0CE',
    'AC85': 'B0CF',
    'AC86': 'B0D0',
    'AC89': 'B0D1',
    'AC8A': 'B0D2',
    'AC8B': 'B0D3',
    'AC8C': 'B0D4',
    'AC90': 'B0D5',
    'AC94': 'B0D6',
    'AC9C': 'B0D7',
    'AC9D': 'B0D8',
    'AC9F': 'B0D9',
    'ACA0': 'B0DA',
    'ACA1': 'B0DB',
    'ACA8': 'B0DC',
    'ACA9': 'B0DD',
    'ACAA': 'B0DE',
    'ACAC': 'B0DF',
    'ACAF': 'B0E0',
    'ACB0': 'B0E1',
    'ACB8': 'B0E2',
    'ACB9': 'B0E3',
    'ACBB': 'B0E4',
    'ACBC': 'B0E5',
    'ACBD': 'B0E6',
    'ACC1': 'B0E7',
    'ACC4': 'B0E8',
    'ACC8': 'B0E9',
    'ACCC': 'B0EA',
    'ACD5': 'B0EB',
    'ACD7': 'B0EC',
    'ACE0': 'B0ED',
    'ACE1': 'B0EE',
    'ACE4': 'B0EF',
    'ACE7': 'B0F0',
    'ACE8': 'B0F1',
    'ACEA': 'B0F2',
    'ACEC': 'B0F3',
    'ACEF': 'B0F4',
    'ACF0': 'B0F5',
    'ACF1': 'B0F6',
    'ACF3': 'B0F7',
    'ACF5': 'B0F8',
    'ACF6': 'B0F9',
    'ACFC': 'B0FA',
    'ACFD': 'B0FB',
    'AD00': 'B0FC',
    'AD04': 'B0FD',
    'AD06': 'B0FE',
    'AD0C': 'B1A1',
    'AD0D': 'B1A2',
    'AD0F': 'B1A3',
    'AD11': 'B1A4',
    'AD18': 'B1A5',
    'AD1C': 'B1A6',
    'AD20': 'B1A7',
    'AD29': 'B1A8',
    'AD2C': 'B1A9',
    'AD2D': 'B1AA',
    'AD34': 'B1AB',
    'AD35': 'B1AC',
    'AD38': 'B1AD',
    'AD3C': 'B1AE',
    'AD44': 'B1AF',
    'AD45': 'B1B0',
    'AD47': 'B1B1',
    'AD49': 'B1B2',
    'AD50': 'B1B3',
    'AD54': 'B1B4',
    'AD58': 'B1B5',
    'AD61': 'B1B6',
    'AD63': 'B1B7',
    'AD6C': 'B1B8',
    'AD6D': 'B1B9',
    'AD70': 'B1BA',
    'AD73': 'B1BB',
    'AD74': 'B1BC',
    'AD75': 'B1BD',
    'AD76': 'B1BE',
    'AD7B': 'B1BF',
    'AD7C': 'B1C0',
    'AD7D': 'B1C1',
    'AD7F': 'B1C2',
    'AD81': 'B1C3',
    'AD82': 'B1C4',
    'AD88': 'B1C5',
    'AD89': 'B1C6',
    'AD8C': 'B1C7',
    'AD90': 'B1C8',
    'AD9C': 'B1C9',
    'AD9D': 'B1CA',
    'ADA4': 'B1CB',
    'ADB7': 'B1CC',
    'ADC0': 'B1CD',
    'ADC1': 'B1CE',
    'ADC4': 'B1CF',
    'ADC8': 'B1D0',
    'ADD0': 'B1D1',
    'ADD1': 'B1D2',
    'ADD3': 'B1D3',
    'ADDC': 'B1D4',
    'ADE0': 'B1D5',
    'ADE4': 'B1D6',
    'ADF8': 'B1D7',
    'ADF9': 'B1D8',
    'ADFC': 'B1D9',
    'ADFF': 'B1DA',
    'AE00': 'B1DB',
    'AE01': 'B1DC',
    'AE08': 'B1DD',
    'AE09': 'B1DE',
    'AE0B': 'B1DF',
    'AE0D': 'B1E0',
    'AE14': 'B1E1',
    'AE30': 'B1E2',
    'AE31': 'B1E3',
    'AE34': 'B1E4',
    'AE37': 'B1E5',
    'AE38': 'B1E6',
    'AE3A': 'B1E7',
    'AE40': 'B1E8',
    'AE41': 'B1E9',
    'AE43': 'B1EA',
    'AE45': 'B1EB',
    'AE46': 'B1EC',
    'AE4A': 'B1ED',
    'AE4C': 'B1EE',
    'AE4D': 'B1EF',
    'AE4E': 'B1F0',
    'AE50': 'B1F1',
    'AE54': 'B1F2',
    'AE56': 'B1F3',
    'AE5C': 'B1F4',
    'AE5D': 'B1F5',
    'AE5F': 'B1F6',
    'AE60': 'B1F7',
    'AE61': 'B1F8',
    'AE65': 'B1F9',
    'AE68': 'B1FA',
    'AE69': 'B1FB',
    'AE6C': 'B1FC',
    'AE70': 'B1FD',
    'AE78': 'B1FE',
    'AE79': 'B2A1',
    'AE7B': 'B2A2',
    'AE7C': 'B2A3',
    'AE7D': 'B2A4',
    'AE84': 'B2A5',
    'AE85': 'B2A6',
    'AE8C': 'B2A7',
    'AEBC': 'B2A8',
    'AEBD': 'B2A9',
    'AEBE': 'B2AA',
    'AEC0': 'B2AB',
    'AEC4': 'B2AC',
    'AECC': 'B2AD',
    'AECD': 'B2AE',
    'AECF': 'B2AF',
    'AED0': 'B2B0',
    'AED1': 'B2B1',
    'AED8': 'B2B2',
    'AED9': 'B2B3',
    'AEDC': 'B2B4',
    'AEE8': 'B2B5',
    'AEEB': 'B2B6',
    'AEED': 'B2B7',
    'AEF4': 'B2B8',
    'AEF8': 'B2B9',
    'AEFC': 'B2BA',
    'AF07': 'B2BB',
    'AF08': 'B2BC',
    'AF0D': 'B2BD',
    'AF10': 'B2BE',
    'AF2C': 'B2BF',
    'AF2D': 'B2C0',
    'AF30': 'B2C1',
    'AF32': 'B2C2',
    'AF34': 'B2C3',
    'AF3C': 'B2C4',
    'AF3D': 'B2C5',
    'AF3F': 'B2C6',
    'AF41': 'B2C7',
    'AF42': 'B2C8',
    'AF43': 'B2C9',
    'AF48': 'B2CA',
    'AF49': 'B2CB',
    'AF50': 'B2CC',
    'AF5C': 'B2CD',
    'AF5D': 'B2CE',
    'AF64': 'B2CF',
    'AF65': 'B2D0',
    'AF79': 'B2D1',
    'AF80': 'B2D2',
    'AF84': 'B2D3',
    'AF88': 'B2D4',
    'AF90': 'B2D5',
    'AF91': 'B2D6',
    'AF95': 'B2D7',
    'AF9C': 'B2D8',
    'AFB8': 'B2D9',
    'AFB9': 'B2DA',
    'AFBC': 'B2DB',
    'AFC0': 'B2DC',
    'AFC7': 'B2DD',
    'AFC8': 'B2DE',
    'AFC9': 'B2DF',
    'AFCB': 'B2E0',
    'AFCD': 'B2E1',
    'AFCE': 'B2E2',
    'AFD4': 'B2E3',
    'AFDC': 'B2E4',
    'AFE8': 'B2E5',
    'AFE9': 'B2E6',
    'AFF0': 'B2E7',
    'AFF1': 'B2E8',
    'AFF4': 'B2E9',
    'AFF8': 'B2EA',
    'B000': 'B2EB',
    'B001': 'B2EC',
    'B004': 'B2ED',
    'B00C': 'B2EE',
    'B010': 'B2EF',
    'B014': 'B2F0',
    'B01C': 'B2F1',
    'B01D': 'B2F2',
    'B028': 'B2F3',
    'B044': 'B2F4',
    'B045': 'B2F5',
    'B048': 'B2F6',
    'B04A': 'B2F7',
    'B04C': 'B2F8',
    'B04E': 'B2F9',
    'B053': 'B2FA',
    'B054': 'B2FB',
    'B055': 'B2FC',
    'B057': 'B2FD',
    'B059': 'B2FE',
    'B05D': 'B3A1',
    'B07C': 'B3A2',
    'B07D': 'B3A3',
    'B080': 'B3A4',
    'B084': 'B3A5',
    'B08C': 'B3A6',
    'B08D': 'B3A7',
    'B08F': 'B3A8',
    'B091': 'B3A9',
    'B098': 'B3AA',
    'B099': 'B3AB',
    'B09A': 'B3AC',
    'B09C': 'B3AD',
    'B09F': 'B3AE',
    'B0A0': 'B3AF',
    'B0A1': 'B3B0',
    'B0A2': 'B3B1',
    'B0A8': 'B3B2',
    'B0A9': 'B3B3',
    'B0AB': 'B3B4',
    'B0AC': 'B3B5',
    'B0AD': 'B3B6',
    'B0AE': 'B3B7',
    'B0AF': 'B3B8',
    'B0B1': 'B3B9',
    'B0B3': 'B3BA',
    'B0B4': 'B3BB',
    'B0B5': 'B3BC',
    'B0B8': 'B3BD',
    'B0BC': 'B3BE',
    'B0C4': 'B3BF',
    'B0C5': 'B3C0',
    'B0C7': 'B3C1',
    'B0C8': 'B3C2',
    'B0C9': 'B3C3',
    'B0D0': 'B3C4',
    'B0D1': 'B3C5',
    'B0D4': 'B3C6',
    'B0D8': 'B3C7',
    'B0E0': 'B3C8',
    'B0E5': 'B3C9',
    'B108': 'B3CA',
    'B109': 'B3CB',
    'B10B': 'B3CC',
    'B10C': 'B3CD',
    'B110': 'B3CE',
    'B112': 'B3CF',
    'B113': 'B3D0',
    'B118': 'B3D1',
    'B119': 'B3D2',
    'B11B': 'B3D3',
    'B11C': 'B3D4',
    'B11D': 'B3D5',
    'B123': 'B3D6',
    'B124': 'B3D7',
    'B125': 'B3D8',
    'B128': 'B3D9',
    'B12C': 'B3DA',
    'B134': 'B3DB',
    'B135': 'B3DC',
    'B137': 'B3DD',
    'B138': 'B3DE',
    'B139': 'B3DF',
    'B140': 'B3E0',
    'B141': 'B3E1',
    'B144': 'B3E2',
    'B148': 'B3E3',
    'B150': 'B3E4',
    'B151': 'B3E5',
    'B154': 'B3E6',
    'B155': 'B3E7',
    'B158': 'B3E8',
    'B15C': 'B3E9',
    'B160': 'B3EA',
    'B178': 'B3EB',
    'B179': 'B3EC',
    'B17C': 'B3ED',
    'B180': 'B3EE',
    'B182': 'B3EF',
    'B188': 'B3F0',
    'B189': 'B3F1',
    'B18B': 'B3F2',
    'B18D': 'B3F3',
    'B192': 'B3F4',
    'B193': 'B3F5',
    'B194': 'B3F6',
    'B198': 'B3F7',
    'B19C': 'B3F8',
    'B1A8': 'B3F9',
    'B1CC': 'B3FA',
    'B1D0': 'B3FB',
    'B1D4': 'B3FC',
    'B1DC': 'B3FD',
    'B1DD': 'B3FE',
    'B1DF': 'B4A1',
    'B1E8': 'B4A2',
    'B1E9': 'B4A3',
    'B1EC': 'B4A4',
    'B1F0': 'B4A5',
    'B1F9': 'B4A6',
    'B1FB': 'B4A7',
    'B1FD': 'B4A8',
    'B204': 'B4A9',
    'B205': 'B4AA',
    'B208': 'B4AB',
    'B20B': 'B4AC',
    'B20C': 'B4AD',
    'B214': 'B4AE',
    'B215': 'B4AF',
    'B217': 'B4B0',
    'B219': 'B4B1',
    'B220': 'B4B2',
    'B234': 'B4B3',
    'B23C': 'B4B4',
    'B258': 'B4B5',
    'B25C': 'B4B6',
    'B260': 'B4B7',
    'B268': 'B4B8',
    'B269': 'B4B9',
    'B274': 'B4BA',
    'B275': 'B4BB',
    'B27C': 'B4BC',
    'B284': 'B4BD',
    'B285': 'B4BE',
    'B289': 'B4BF',
    'B290': 'B4C0',
    'B291': 'B4C1',
    'B294': 'B4C2',
    'B298': 'B4C3',
    'B299': 'B4C4',
    'B29A': 'B4C5',
    'B2A0': 'B4C6',
    'B2A1': 'B4C7',
    'B2A3': 'B4C8',
    'B2A5': 'B4C9',
    'B2A6': 'B4CA',
    'B2AA': 'B4CB',
    'B2AC': 'B4CC',
    'B2B0': 'B4CD',
    'B2B4': 'B4CE',
    'B2C8': 'B4CF',
    'B2C9': 'B4D0',
    'B2CC': 'B4D1',
    'B2D0': 'B4D2',
    'B2D2': 'B4D3',
    'B2D8': 'B4D4',
    'B2D9': 'B4D5',
    'B2DB': 'B4D6',
    'B2DD': 'B4D7',
    'B2E2': 'B4D8',
    'B2E4': 'B4D9',
    'B2E5': 'B4DA',
    'B2E6': 'B4DB',
    'B2E8': 'B4DC',
    'B2EB': 'B4DD',
    'B2EC': 'B4DE',
    'B2ED': 'B4DF',
    'B2EE': 'B4E0',
    'B2EF': 'B4E1',
    'B2F3': 'B4E2',
    'B2F4': 'B4E3',
    'B2F5': 'B4E4',
    'B2F7': 'B4E5',
    'B2F8': 'B4E6',
    'B2F9': 'B4E7',
    'B2FA': 'B4E8',
    'B2FB': 'B4E9',
    'B2FF': 'B4EA',
    'B300': 'B4EB',
    'B301': 'B4EC',
    'B304': 'B4ED',
    'B308': 'B4EE',
    'B310': 'B4EF',
    'B311': 'B4F0',
    'B313': 'B4F1',
    'B314': 'B4F2',
    'B315': 'B4F3',
    'B31C': 'B4F4',
    'B354': 'B4F5',
    'B355': 'B4F6',
    'B356': 'B4F7',
    'B358': 'B4F8',
    'B35B': 'B4F9',
    'B35C': 'B4FA',
    'B35E': 'B4FB',
    'B35F': 'B4FC',
    'B364': 'B4FD',
    'B365': 'B4FE',
    'B367': 'B5A1',
    'B369': 'B5A2',
    'B36B': 'B5A3',
    'B36E': 'B5A4',
    'B370': 'B5A5',
    'B371': 'B5A6',
    'B374': 'B5A7',
    'B378': 'B5A8',
    'B380': 'B5A9',
    'B381': 'B5AA',
    'B383': 'B5AB',
    'B384': 'B5AC',
    'B385': 'B5AD',
    'B38C': 'B5AE',
    'B390': 'B5AF',
    'B394': 'B5B0',
    'B3A0': 'B5B1',
    'B3A1': 'B5B2',
    'B3A8': 'B5B3',
    'B3AC': 'B5B4',
    'B3C4': 'B5B5',
    'B3C5': 'B5B6',
    'B3C8': 'B5B7',
    'B3CB': 'B5B8',
    'B3CC': 'B5B9',
    'B3CE': 'B5BA',
    'B3D0': 'B5BB',
    'B3D4': 'B5BC',
    'B3D5': 'B5BD',
    'B3D7': 'B5BE',
    'B3D9': 'B5BF',
    'B3DB': 'B5C0',
    'B3DD': 'B5C1',
    'B3E0': 'B5C2',
    'B3E4': 'B5C3',
    'B3E8': 'B5C4',
    'B3FC': 'B5C5',
    'B410': 'B5C6',
    'B418': 'B5C7',
    'B41C': 'B5C8',
    'B420': 'B5C9',
    'B428': 'B5CA',
    'B429': 'B5CB',
    'B42B': 'B5CC',
    'B434': 'B5CD',
    'B450': 'B5CE',
    'B451': 'B5CF',
    'B454': 'B5D0',
    'B458': 'B5D1',
    'B460': 'B5D2',
    'B461': 'B5D3',
    'B463': 'B5D4',
    'B465': 'B5D5',
    'B46C': 'B5D6',
    'B480': 'B5D7',
    'B488': 'B5D8',
    'B49D': 'B5D9',
    'B4A4': 'B5DA',
    'B4A8': 'B5DB',
    'B4AC': 'B5DC',
    'B4B5': 'B5DD',
    'B4B7': 'B5DE',
    'B4B9': 'B5DF',
    'B4C0': 'B5E0',
    'B4C4': 'B5E1',
    'B4C8': 'B5E2',
    'B4D0': 'B5E3',
    'B4D5': 'B5E4',
    'B4DC': 'B5E5',
    'B4DD': 'B5E6',
    'B4E0': 'B5E7',
    'B4E3': 'B5E8',
    'B4E4': 'B5E9',
    'B4E6': 'B5EA',
    'B4EC': 'B5EB',
    'B4ED': 'B5EC',
    'B4EF': 'B5ED',
    'B4F1': 'B5EE',
    'B4F8': 'B5EF',
    'B514': 'B5F0',
    'B515': 'B5F1',
    'B518': 'B5F2',
    'B51B': 'B5F3',
    'B51C': 'B5F4',
    'B524': 'B5F5',
    'B525': 'B5F6',
    'B527': 'B5F7',
    'B528': 'B5F8',
    'B529': 'B5F9',
    'B52A': 'B5FA',
    'B530': 'B5FB',
    'B531': 'B5FC',
    'B534': 'B5FD',
    'B538': 'B5FE',
    'B540': 'B6A1',
    'B541': 'B6A2',
    'B543': 'B6A3',
    'B544': 'B6A4',
    'B545': 'B6A5',
    'B54B': 'B6A6',
    'B54C': 'B6A7',
    'B54D': 'B6A8',
    'B550': 'B6A9',
    'B554': 'B6AA',
    'B55C': 'B6AB',
    'B55D': 'B6AC',
    'B55F': 'B6AD',
    'B560': 'B6AE',
    'B561': 'B6AF',
    'B5A0': 'B6B0',
    'B5A1': 'B6B1',
    'B5A4': 'B6B2',
    'B5A8': 'B6B3',
    'B5AA': 'B6B4',
    'B5AB': 'B6B5',
    'B5B0': 'B6B6',
    'B5B1': 'B6B7',
    'B5B3': 'B6B8',
    'B5B4': 'B6B9',
    'B5B5': 'B6BA',
    'B5BB': 'B6BB',
    'B5BC': 'B6BC',
    'B5BD': 'B6BD',
    'B5C0': 'B6BE',
    'B5C4': 'B6BF',
    'B5CC': 'B6C0',
    'B5CD': 'B6C1',
    'B5CF': 'B6C2',
    'B5D0': 'B6C3',
    'B5D1': 'B6C4',
    'B5D8': 'B6C5',
    'B5EC': 'B6C6',
    'B610': 'B6C7',
    'B611': 'B6C8',
    'B614': 'B6C9',
    'B618': 'B6CA',
    'B625': 'B6CB',
    'B62C': 'B6CC',
    'B634': 'B6CD',
    'B648': 'B6CE',
    'B664': 'B6CF',
    'B668': 'B6D0',
    'B69C': 'B6D1',
    'B69D': 'B6D2',
    'B6A0': 'B6D3',
    'B6A4': 'B6D4',
    'B6AB': 'B6D5',
    'B6AC': 'B6D6',
    'B6B1': 'B6D7',
    'B6D4': 'B6D8',
    'B6F0': 'B6D9',
    'B6F4': 'B6DA',
    'B6F8': 'B6DB',
    'B700': 'B6DC',
    'B701': 'B6DD',
    'B705': 'B6DE',
    'B728': 'B6DF',
    'B729': 'B6E0',
    'B72C': 'B6E1',
    'B72F': 'B6E2',
    'B730': 'B6E3',
    'B738': 'B6E4',
    'B739': 'B6E5',
    'B73B': 'B6E6',
    'B744': 'B6E7',
    'B748': 'B6E8',
    'B74C': 'B6E9',
    'B754': 'B6EA',
    'B755': 'B6EB',
    'B760': 'B6EC',
    'B764': 'B6ED',
    'B768': 'B6EE',
    'B770': 'B6EF',
    'B771': 'B6F0',
    'B773': 'B6F1',
    'B775': 'B6F2',
    'B77C': 'B6F3',
    'B77D': 'B6F4',
    'B780': 'B6F5',
    'B784': 'B6F6',
    'B78C': 'B6F7',
    'B78D': 'B6F8',
    'B78F': 'B6F9',
    'B790': 'B6FA',
    'B791': 'B6FB',
    'B792': 'B6FC',
    'B796': 'B6FD',
    'B797': 'B6FE',
    'B798': 'B7A1',
    'B799': 'B7A2',
    'B79C': 'B7A3',
    'B7A0': 'B7A4',
    'B7A8': 'B7A5',
    'B7A9': 'B7A6',
    'B7AB': 'B7A7',
    'B7AC': 'B7A8',
    'B7AD': 'B7A9',
    'B7B4': 'B7AA',
    'B7B5': 'B7AB',
    'B7B8': 'B7AC',
    'B7C7': 'B7AD',
    'B7C9': 'B7AE',
    'B7EC': 'B7AF',
    'B7ED': 'B7B0',
    'B7F0': 'B7B1',
    'B7F4': 'B7B2',
    'B7FC': 'B7B3',
    'B7FD': 'B7B4',
    'B7FF': 'B7B5',
    'B800': 'B7B6',
    'B801': 'B7B7',
    'B807': 'B7B8',
    'B808': 'B7B9',
    'B809': 'B7BA',
    'B80C': 'B7BB',
    'B810': 'B7BC',
    'B818': 'B7BD',
    'B819': 'B7BE',
    'B81B': 'B7BF',
    'B81D': 'B7C0',
    'B824': 'B7C1',
    'B825': 'B7C2',
    'B828': 'B7C3',
    'B82C': 'B7C4',
    'B834': 'B7C5',
    'B835': 'B7C6',
    'B837': 'B7C7',
    'B838': 'B7C8',
    'B839': 'B7C9',
    'B840': 'B7CA',
    'B844': 'B7CB',
    'B851': 'B7CC',
    'B853': 'B7CD',
    'B85C': 'B7CE',
    'B85D': 'B7CF',
    'B860': 'B7D0',
    'B864': 'B7D1',
    'B86C': 'B7D2',
    'B86D': 'B7D3',
    'B86F': 'B7D4',
    'B871': 'B7D5',
    'B878': 'B7D6',
    'B87C': 'B7D7',
    'B88D': 'B7D8',
    'B8A8': 'B7D9',
    'B8B0': 'B7DA',
    'B8B4': 'B7DB',
    'B8B8': 'B7DC',
    'B8C0': 'B7DD',
    'B8C1': 'B7DE',
    'B8C3': 'B7DF',
    'B8C5': 'B7E0',
    'B8CC': 'B7E1',
    'B8D0': 'B7E2',
    'B8D4': 'B7E3',
    'B8DD': 'B7E4',
    'B8DF': 'B7E5',
    'B8E1': 'B7E6',
    'B8E8': 'B7E7',
    'B8E9': 'B7E8',
    'B8EC': 'B7E9',
    'B8F0': 'B7EA',
    'B8F8': 'B7EB',
    'B8F9': 'B7EC',
    'B8FB': 'B7ED',
    'B8FD': 'B7EE',
    'B904': 'B7EF',
    'B918': 'B7F0',
    'B920': 'B7F1',
    'B93C': 'B7F2',
    'B93D': 'B7F3',
    'B940': 'B7F4',
    'B944': 'B7F5',
    'B94C': 'B7F6',
    'B94F': 'B7F7',
    'B951': 'B7F8',
    'B958': 'B7F9',
    'B959': 'B7FA',
    'B95C': 'B7FB',
    'B960': 'B7FC',
    'B968': 'B7FD',
    'B969': 'B7FE',
    'B96B': 'B8A1',
    'B96D': 'B8A2',
    'B974': 'B8A3',
    'B975': 'B8A4',
    'B978': 'B8A5',
    'B97C': 'B8A6',
    'B984': 'B8A7',
    'B985': 'B8A8',
    'B987': 'B8A9',
    'B989': 'B8AA',
    'B98A': 'B8AB',
    'B98D': 'B8AC',
    'B98E': 'B8AD',
    'B9AC': 'B8AE',
    'B9AD': 'B8AF',
    'B9B0': 'B8B0',
    'B9B4': 'B8B1',
    'B9BC': 'B8B2',
    'B9BD': 'B8B3',
    'B9BF': 'B8B4',
    'B9C1': 'B8B5',
    'B9C8': 'B8B6',
    'B9C9': 'B8B7',
    'B9CC': 'B8B8',
    'B9CE': 'B8B9',
    'B9CF': 'B8BA',
    'B9D0': 'B8BB',
    'B9D1': 'B8BC',
    'B9D2': 'B8BD',
    'B9D8': 'B8BE',
    'B9D9': 'B8BF',
    'B9DB': 'B8C0',
    'B9DD': 'B8C1',
    'B9DE': 'B8C2',
    'B9E1': 'B8C3',
    'B9E3': 'B8C4',
    'B9E4': 'B8C5',
    'B9E5': 'B8C6',
    'B9E8': 'B8C7',
    'B9EC': 'B8C8',
    'B9F4': 'B8C9',
    'B9F5': 'B8CA',
    'B9F7': 'B8CB',
    'B9F8': 'B8CC',
    'B9F9': 'B8CD',
    'B9FA': 'B8CE',
    'BA00': 'B8CF',
    'BA01': 'B8D0',
    'BA08': 'B8D1',
    'BA15': 'B8D2',
    'BA38': 'B8D3',
    'BA39': 'B8D4',
    'BA3C': 'B8D5',
    'BA40': 'B8D6',
    'BA42': 'B8D7',
    'BA48': 'B8D8',
    'BA49': 'B8D9',
    'BA4B': 'B8DA',
    'BA4D': 'B8DB',
    'BA4E': 'B8DC',
    'BA53': 'B8DD',
    'BA54': 'B8DE',
    'BA55': 'B8DF',
    'BA58': 'B8E0',
    'BA5C': 'B8E1',
    'BA64': 'B8E2',
    'BA65': 'B8E3',
    'BA67': 'B8E4',
    'BA68': 'B8E5',
    'BA69': 'B8E6',
    'BA70': 'B8E7',
    'BA71': 'B8E8',
    'BA74': 'B8E9',
    'BA78': 'B8EA',
    'BA83': 'B8EB',
    'BA84': 'B8EC',
    'BA85': 'B8ED',
    'BA87': 'B8EE',
    'BA8C': 'B8EF',
    'BAA8': 'B8F0',
    'BAA9': 'B8F1',
    'BAAB': 'B8F2',
    'BAAC': 'B8F3',
    'BAB0': 'B8F4',
    'BAB2': 'B8F5',
    'BAB8': 'B8F6',
    'BAB9': 'B8F7',
    'BABB': 'B8F8',
    'BABD': 'B8F9',
    'BAC4': 'B8FA',
    'BAC8': 'B8FB',
    'BAD8': 'B8FC',
    'BAD9': 'B8FD',
    'BAFC': 'B8FE',
    'BB00': 'B9A1',
    'BB04': 'B9A2',
    'BB0D': 'B9A3',
    'BB0F': 'B9A4',
    'BB11': 'B9A5',
    'BB18': 'B9A6',
    'BB1C': 'B9A7',
    'BB20': 'B9A8',
    'BB29': 'B9A9',
    'BB2B': 'B9AA',
    'BB34': 'B9AB',
    'BB35': 'B9AC',
    'BB36': 'B9AD',
    'BB38': 'B9AE',
    'BB3B': 'B9AF',
    'BB3C': 'B9B0',
    'BB3D': 'B9B1',
    'BB3E': 'B9B2',
    'BB44': 'B9B3',
    'BB45': 'B9B4',
    'BB47': 'B9B5',
    'BB49': 'B9B6',
    'BB4D': 'B9B7',
    'BB4F': 'B9B8',
    'BB50': 'B9B9',
    'BB54': 'B9BA',
    'BB58': 'B9BB',
    'BB61': 'B9BC',
    'BB63': 'B9BD',
    'BB6C': 'B9BE',
    'BB88': 'B9BF',
    'BB8C': 'B9C0',
    'BB90': 'B9C1',
    'BBA4': 'B9C2',
    'BBA8': 'B9C3',
    'BBAC': 'B9C4',
    'BBB4': 'B9C5',
    'BBB7': 'B9C6',
    'BBC0': 'B9C7',
    'BBC4': 'B9C8',
    'BBC8': 'B9C9',
    'BBD0': 'B9CA',
    'BBD3': 'B9CB',
    'BBF8': 'B9CC',
    'BBF9': 'B9CD',
    'BBFC': 'B9CE',
    'BBFF': 'B9CF',
    'BC00': 'B9D0',
    'BC02': 'B9D1',
    'BC08': 'B9D2',
    'BC09': 'B9D3',
    'BC0B': 'B9D4',
    'BC0C': 'B9D5',
    'BC0D': 'B9D6',
    'BC0F': 'B9D7',
    'BC11': 'B9D8',
    'BC14': 'B9D9',
    'BC15': 'B9DA',
    'BC16': 'B9DB',
    'BC17': 'B9DC',
    'BC18': 'B9DD',
    'BC1B': 'B9DE',
    'BC1C': 'B9DF',
    'BC1D': 'B9E0',
    'BC1E': 'B9E1',
    'BC1F': 'B9E2',
    'BC24': 'B9E3',
    'BC25': 'B9E4',
    'BC27': 'B9E5',
    'BC29': 'B9E6',
    'BC2D': 'B9E7',
    'BC30': 'B9E8',
    'BC31': 'B9E9',
    'BC34': 'B9EA',
    'BC38': 'B9EB',
    'BC40': 'B9EC',
    'BC41': 'B9ED',
    'BC43': 'B9EE',
    'BC44': 'B9EF',
    'BC45': 'B9F0',
    'BC49': 'B9F1',
    'BC4C': 'B9F2',
    'BC4D': 'B9F3',
    'BC50': 'B9F4',
    'BC5D': 'B9F5',
    'BC84': 'B9F6',
    'BC85': 'B9F7',
    'BC88': 'B9F8',
    'BC8B': 'B9F9',
    'BC8C': 'B9FA',
    'BC8E': 'B9FB',
    'BC94': 'B9FC',
    'BC95': 'B9FD',
    'BC97': 'B9FE',
    'BC99': 'BAA1',
    'BC9A': 'BAA2',
    'BCA0': 'BAA3',
    'BCA1': 'BAA4',
    'BCA4': 'BAA5',
    'BCA7': 'BAA6',
    'BCA8': 'BAA7',
    'BCB0': 'BAA8',
    'BCB1': 'BAA9',
    'BCB3': 'BAAA',
    'BCB4': 'BAAB',
    'BCB5': 'BAAC',
    'BCBC': 'BAAD',
    'BCBD': 'BAAE',
    'BCC0': 'BAAF',
    'BCC4': 'BAB0',
    'BCCD': 'BAB1',
    'BCCF': 'BAB2',
    'BCD0': 'BAB3',
    'BCD1': 'BAB4',
    'BCD5': 'BAB5',
    'BCD8': 'BAB6',
    'BCDC': 'BAB7',
    'BCF4': 'BAB8',
    'BCF5': 'BAB9',
    'BCF6': 'BABA',
    'BCF8': 'BABB',
    'BCFC': 'BABC',
    'BD04': 'BABD',
    'BD05': 'BABE',
    'BD07': 'BABF',
    'BD09': 'BAC0',
    'BD10': 'BAC1',
    'BD14': 'BAC2',
    'BD24': 'BAC3',
    'BD2C': 'BAC4',
    'BD40': 'BAC5',
    'BD48': 'BAC6',
    'BD49': 'BAC7',
    'BD4C': 'BAC8',
    'BD50': 'BAC9',
    'BD58': 'BACA',
    'BD59': 'BACB',
    'BD64': 'BACC',
    'BD68': 'BACD',
    'BD80': 'BACE',
    'BD81': 'BACF',
    'BD84': 'BAD0',
    'BD87': 'BAD1',
    'BD88': 'BAD2',
    'BD89': 'BAD3',
    'BD8A': 'BAD4',
    'BD90': 'BAD5',
    'BD91': 'BAD6',
    'BD93': 'BAD7',
    'BD95': 'BAD8',
    'BD99': 'BAD9',
    'BD9A': 'BADA',
    'BD9C': 'BADB',
    'BDA4': 'BADC',
    'BDB0': 'BADD',
    'BDB8': 'BADE',
    'BDD4': 'BADF',
    'BDD5': 'BAE0',
    'BDD8': 'BAE1',
    'BDDC': 'BAE2',
    'BDE9': 'BAE3',
    'BDF0': 'BAE4',
    'BDF4': 'BAE5',
    'BDF8': 'BAE6',
    'BE00': 'BAE7',
    'BE03': 'BAE8',
    'BE05': 'BAE9',
    'BE0C': 'BAEA',
    'BE0D': 'BAEB',
    'BE10': 'BAEC',
    'BE14': 'BAED',
    'BE1C': 'BAEE',
    'BE1D': 'BAEF',
    'BE1F': 'BAF0',
    'BE44': 'BAF1',
    'BE45': 'BAF2',
    'BE48': 'BAF3',
    'BE4C': 'BAF4',
    'BE4E': 'BAF5',
    'BE54': 'BAF6',
    'BE55': 'BAF7',
    'BE57': 'BAF8',
    'BE59': 'BAF9',
    'BE5A': 'BAFA',
    'BE5B': 'BAFB',
    'BE60': 'BAFC',
    'BE61': 'BAFD',
    'BE64': 'BAFE',
    'BE68': 'BBA1',
    'BE6A': 'BBA2',
    'BE70': 'BBA3',
    'BE71': 'BBA4',
    'BE73': 'BBA5',
    'BE74': 'BBA6',
    'BE75': 'BBA7',
    'BE7B': 'BBA8',
    'BE7C': 'BBA9',
    'BE7D': 'BBAA',
    'BE80': 'BBAB',
    'BE84': 'BBAC',
    'BE8C': 'BBAD',
    'BE8D': 'BBAE',
    'BE8F': 'BBAF',
    'BE90': 'BBB0',
    'BE91': 'BBB1',
    'BE98': 'BBB2',
    'BE99': 'BBB3',
    'BEA8': 'BBB4',
    'BED0': 'BBB5',
    'BED1': 'BBB6',
    'BED4': 'BBB7',
    'BED7': 'BBB8',
    'BED8': 'BBB9',
    'BEE0': 'BBBA',
    'BEE3': 'BBBB',
    'BEE4': 'BBBC',
    'BEE5': 'BBBD',
    'BEEC': 'BBBE',
    'BF01': 'BBBF',
    'BF08': 'BBC0',
    'BF09': 'BBC1',
    'BF18': 'BBC2',
    'BF19': 'BBC3',
    'BF1B': 'BBC4',
    'BF1C': 'BBC5',
    'BF1D': 'BBC6',
    'BF40': 'BBC7',
    'BF41': 'BBC8',
    'BF44': 'BBC9',
    'BF48': 'BBCA',
    'BF50': 'BBCB',
    'BF51': 'BBCC',
    'BF55': 'BBCD',
    'BF94': 'BBCE',
    'BFB0': 'BBCF',
    'BFC5': 'BBD0',
    'BFCC': 'BBD1',
    'BFCD': 'BBD2',
    'BFD0': 'BBD3',
    'BFD4': 'BBD4',
    'BFDC': 'BBD5',
    'BFDF': 'BBD6',
    'BFE1': 'BBD7',
    'C03C': 'BBD8',
    'C051': 'BBD9',
    'C058': 'BBDA',
    'C05C': 'BBDB',
    'C060': 'BBDC',
    'C068': 'BBDD',
    'C069': 'BBDE',
    'C090': 'BBDF',
    'C091': 'BBE0',
    'C094': 'BBE1',
    'C098': 'BBE2',
    'C0A0': 'BBE3',
    'C0A1': 'BBE4',
    'C0A3': 'BBE5',
    'C0A5': 'BBE6',
    'C0AC': 'BBE7',
    'C0AD': 'BBE8',
    'C0AF': 'BBE9',
    'C0B0': 'BBEA',
    'C0B3': 'BBEB',
    'C0B4': 'BBEC',
    'C0B5': 'BBED',
    'C0B6': 'BBEE',
    'C0BC': 'BBEF',
    'C0BD': 'BBF0',
    'C0BF': 'BBF1',
    'C0C0': 'BBF2',
    'C0C1': 'BBF3',
    'C0C5': 'BBF4',
    'C0C8': 'BBF5',
    'C0C9': 'BBF6',
    'C0CC': 'BBF7',
    'C0D0': 'BBF8',
    'C0D8': 'BBF9',
    'C0D9': 'BBFA',
    'C0DB': 'BBFB',
    'C0DC': 'BBFC',
    'C0DD': 'BBFD',
    'C0E4': 'BBFE',
    'C0E5': 'BCA1',
    'C0E8': 'BCA2',
    'C0EC': 'BCA3',
    'C0F4': 'BCA4',
    'C0F5': 'BCA5',
    'C0F7': 'BCA6',
    'C0F9': 'BCA7',
    'C100': 'BCA8',
    'C104': 'BCA9',
    'C108': 'BCAA',
    'C110': 'BCAB',
    'C115': 'BCAC',
    'C11C': 'BCAD',
    'C11D': 'BCAE',
    'C11E': 'BCAF',
    'C11F': 'BCB0',
    'C120': 'BCB1',
    'C123': 'BCB2',
    'C124': 'BCB3',
    'C126': 'BCB4',
    'C127': 'BCB5',
    'C12C': 'BCB6',
    'C12D': 'BCB7',
    'C12F': 'BCB8',
    'C130': 'BCB9',
    'C131': 'BCBA',
    'C136': 'BCBB',
    'C138': 'BCBC',
    'C139': 'BCBD',
    'C13C': 'BCBE',
    'C140': 'BCBF',
    'C148': 'BCC0',
    'C149': 'BCC1',
    'C14B': 'BCC2',
    'C14C': 'BCC3',
    'C14D': 'BCC4',
    'C154': 'BCC5',
    'C155': 'BCC6',
    'C158': 'BCC7',
    'C15C': 'BCC8',
    'C164': 'BCC9',
    'C165': 'BCCA',
    'C167': 'BCCB',
    'C168': 'BCCC',
    'C169': 'BCCD',
    'C170': 'BCCE',
    'C174': 'BCCF',
    'C178': 'BCD0',
    'C185': 'BCD1',
    'C18C': 'BCD2',
    'C18D': 'BCD3',
    'C18E': 'BCD4',
    'C190': 'BCD5',
    'C194': 'BCD6',
    'C196': 'BCD7',
    'C19C': 'BCD8',
    'C19D': 'BCD9',
    'C19F': 'BCDA',
    'C1A1': 'BCDB',
    'C1A5': 'BCDC',
    'C1A8': 'BCDD',
    'C1A9': 'BCDE',
    'C1AC': 'BCDF',
    'C1B0': 'BCE0',
    'C1BD': 'BCE1',
    'C1C4': 'BCE2',
    'C1C8': 'BCE3',
    'C1CC': 'BCE4',
    'C1D4': 'BCE5',
    'C1D7': 'BCE6',
    'C1D8': 'BCE7',
    'C1E0': 'BCE8',
    'C1E4': 'BCE9',
    'C1E8': 'BCEA',
    'C1F0': 'BCEB',
    'C1F1': 'BCEC',
    'C1F3': 'BCED',
    'C1FC': 'BCEE',
    'C1FD': 'BCEF',
    'C200': 'BCF0',
    'C204': 'BCF1',
    'C20C': 'BCF2',
    'C20D': 'BCF3',
    'C20F': 'BCF4',
    'C211': 'BCF5',
    'C218': 'BCF6',
    'C219': 'BCF7',
    'C21C': 'BCF8',
    'C21F': 'BCF9',
    'C220': 'BCFA',
    'C228': 'BCFB',
    'C229': 'BCFC',
    'C22B': 'BCFD',
    'C22D': 'BCFE',
    'C22F': 'BDA1',
    'C231': 'BDA2',
    'C232': 'BDA3',
    'C234': 'BDA4',
    'C248': 'BDA5',
    'C250': 'BDA6',
    'C251': 'BDA7',
    'C254': 'BDA8',
    'C258': 'BDA9',
    'C260': 'BDAA',
    'C265': 'BDAB',
    'C26C': 'BDAC',
    'C26D': 'BDAD',
    'C270': 'BDAE',
    'C274': 'BDAF',
    'C27C': 'BDB0',
    'C27D': 'BDB1',
    'C27F': 'BDB2',
    'C281': 'BDB3',
    'C288': 'BDB4',
    'C289': 'BDB5',
    'C290': 'BDB6',
    'C298': 'BDB7',
    'C29B': 'BDB8',
    'C29D': 'BDB9',
    'C2A4': 'BDBA',
    'C2A5': 'BDBB',
    'C2A8': 'BDBC',
    'C2AC': 'BDBD',
    'C2AD': 'BDBE',
    'C2B4': 'BDBF',
    'C2B5': 'BDC0',
    'C2B7': 'BDC1',
    'C2B9': 'BDC2',
    'C2DC': 'BDC3',
    'C2DD': 'BDC4',
    'C2E0': 'BDC5',
    'C2E3': 'BDC6',
    'C2E4': 'BDC7',
    'C2EB': 'BDC8',
    'C2EC': 'BDC9',
    'C2ED': 'BDCA',
    'C2EF': 'BDCB',
    'C2F1': 'BDCC',
    'C2F6': 'BDCD',
    'C2F8': 'BDCE',
    'C2F9': 'BDCF',
    'C2FB': 'BDD0',
    'C2FC': 'BDD1',
    'C300': 'BDD2',
    'C308': 'BDD3',
    'C309': 'BDD4',
    'C30C': 'BDD5',
    'C30D': 'BDD6',
    'C313': 'BDD7',
    'C314': 'BDD8',
    'C315': 'BDD9',
    'C318': 'BDDA',
    'C31C': 'BDDB',
    'C324': 'BDDC',
    'C325': 'BDDD',
    'C328': 'BDDE',
    'C329': 'BDDF',
    'C345': 'BDE0',
    'C368': 'BDE1',
    'C369': 'BDE2',
    'C36C': 'BDE3',
    'C370': 'BDE4',
    'C372': 'BDE5',
    'C378': 'BDE6',
    'C379': 'BDE7',
    'C37C': 'BDE8',
    'C37D': 'BDE9',
    'C384': 'BDEA',
    'C388': 'BDEB',
    'C38C': 'BDEC',
    'C3C0': 'BDED',
    'C3D8': 'BDEE',
    'C3D9': 'BDEF',
    'C3DC': 'BDF0',
    'C3DF': 'BDF1',
    'C3E0': 'BDF2',
    'C3E2': 'BDF3',
    'C3E8': 'BDF4',
    'C3E9': 'BDF5',
    'C3ED': 'BDF6',
    'C3F4': 'BDF7',
    'C3F5': 'BDF8',
    'C3F8': 'BDF9',
    'C408': 'BDFA',
    'C410': 'BDFB',
    'C424': 'BDFC',
    'C42C': 'BDFD',
    'C430': 'BDFE',
    'C434': 'BEA1',
    'C43C': 'BEA2',
    'C43D': 'BEA3',
    'C448': 'BEA4',
    'C464': 'BEA5',
    'C465': 'BEA6',
    'C468': 'BEA7',
    'C46C': 'BEA8',
    'C474': 'BEA9',
    'C475': 'BEAA',
    'C479': 'BEAB',
    'C480': 'BEAC',
    'C494': 'BEAD',
    'C49C': 'BEAE',
    'C4B8': 'BEAF',
    'C4BC': 'BEB0',
    'C4E9': 'BEB1',
    'C4F0': 'BEB2',
    'C4F1': 'BEB3',
    'C4F4': 'BEB4',
    'C4F8': 'BEB5',
    'C4FA': 'BEB6',
    'C4FF': 'BEB7',
    'C500': 'BEB8',
    'C501': 'BEB9',
    'C50C': 'BEBA',
    'C510': 'BEBB',
    'C514': 'BEBC',
    'C51C': 'BEBD',
    'C528': 'BEBE',
    'C529': 'BEBF',
    'C52C': 'BEC0',
    'C530': 'BEC1',
    'C538': 'BEC2',
    'C539': 'BEC3',
    'C53B': 'BEC4',
    'C53D': 'BEC5',
    'C544': 'BEC6',
    'C545': 'BEC7',
    'C548': 'BEC8',
    'C549': 'BEC9',
    'C54A': 'BECA',
    'C54C': 'BECB',
    'C54D': 'BECC',
    'C54E': 'BECD',
    'C553': 'BECE',
    'C554': 'BECF',
    'C555': 'BED0',
    'C557': 'BED1',
    'C558': 'BED2',
    'C559': 'BED3',
    'C55D': 'BED4',
    'C55E': 'BED5',
    'C560': 'BED6',
    'C561': 'BED7',
    'C564': 'BED8',
    'C568': 'BED9',
    'C570': 'BEDA',
    'C571': 'BEDB',
    'C573': 'BEDC',
    'C574': 'BEDD',
    'C575': 'BEDE',
    'C57C': 'BEDF',
    'C57D': 'BEE0',
    'C580': 'BEE1',
    'C584': 'BEE2',
    'C587': 'BEE3',
    'C58C': 'BEE4',
    'C58D': 'BEE5',
    'C58F': 'BEE6',
    'C591': 'BEE7',
    'C595': 'BEE8',
    'C597': 'BEE9',
    'C598': 'BEEA',
    'C59C': 'BEEB',
    'C5A0': 'BEEC',
    'C5A9': 'BEED',
    'C5B4': 'BEEE',
    'C5B5': 'BEEF',
    'C5B8': 'BEF0',
    'C5B9': 'BEF1',
    'C5BB': 'BEF2',
    'C5BC': 'BEF3',
    'C5BD': 'BEF4',
    'C5BE': 'BEF5',
    'C5C4': 'BEF6',
    'C5C5': 'BEF7',
    'C5C6': 'BEF8',
    'C5C7': 'BEF9',
    'C5C8': 'BEFA',
    'C5C9': 'BEFB',
    'C5CA': 'BEFC',
    'C5CC': 'BEFD',
    'C5CE': 'BEFE',
    'C5D0': 'BFA1',
    'C5D1': 'BFA2',
    'C5D4': 'BFA3',
    'C5D8': 'BFA4',
    'C5E0': 'BFA5',
    'C5E1': 'BFA6',
    'C5E3': 'BFA7',
    'C5E5': 'BFA8',
    'C5EC': 'BFA9',
    'C5ED': 'BFAA',
    'C5EE': 'BFAB',
    'C5F0': 'BFAC',
    'C5F4': 'BFAD',
    'C5F6': 'BFAE',
    'C5F7': 'BFAF',
    'C5FC': 'BFB0',
    'C5FD': 'BFB1',
    'C5FE': 'BFB2',
    'C5FF': 'BFB3',
    'C600': 'BFB4',
    'C601': 'BFB5',
    'C605': 'BFB6',
    'C606': 'BFB7',
    'C607': 'BFB8',
    'C608': 'BFB9',
    'C60C': 'BFBA',
    'C610': 'BFBB',
    'C618': 'BFBC',
    'C619': 'BFBD',
    'C61B': 'BFBE',
    'C61C': 'BFBF',
    'C624': 'BFC0',
    'C625': 'BFC1',
    'C628': 'BFC2',
    'C62C': 'BFC3',
    'C62D': 'BFC4',
    'C62E': 'BFC5',
    'C630': 'BFC6',
    'C633': 'BFC7',
    'C634': 'BFC8',
    'C635': 'BFC9',
    'C637': 'BFCA',
    'C639': 'BFCB',
    'C63B': 'BFCC',
    'C640': 'BFCD',
    'C641': 'BFCE',
    'C644': 'BFCF',
    'C648': 'BFD0',
    'C650': 'BFD1',
    'C651': 'BFD2',
    'C653': 'BFD3',
    'C654': 'BFD4',
    'C655': 'BFD5',
    'C65C': 'BFD6',
    'C65D': 'BFD7',
    'C660': 'BFD8',
    'C66C': 'BFD9',
    'C66F': 'BFDA',
    'C671': 'BFDB',
    'C678': 'BFDC',
    'C679': 'BFDD',
    'C67C': 'BFDE',
    'C680': 'BFDF',
    'C688': 'BFE0',
    'C689': 'BFE1',
    'C68B': 'BFE2',
    'C68D': 'BFE3',
    'C694': 'BFE4',
    'C695': 'BFE5',
    'C698': 'BFE6',
    'C69C': 'BFE7',
    'C6A4': 'BFE8',
    'C6A5': 'BFE9',
    'C6A7': 'BFEA',
    'C6A9': 'BFEB',
    'C6B0': 'BFEC',
    'C6B1': 'BFED',
    'C6B4': 'BFEE',
    'C6B8': 'BFEF',
    'C6B9': 'BFF0',
    'C6BA': 'BFF1',
    'C6C0': 'BFF2',
    'C6C1': 'BFF3',
    'C6C3': 'BFF4',
    'C6C5': 'BFF5',
    'C6CC': 'BFF6',
    'C6CD': 'BFF7',
    'C6D0': 'BFF8',
    'C6D4': 'BFF9',
    'C6DC': 'BFFA',
    'C6DD': 'BFFB',
    'C6E0': 'BFFC',
    'C6E1': 'BFFD',
    'C6E8': 'BFFE',
    'C6E9': 'C0A1',
    'C6EC': 'C0A2',
    'C6F0': 'C0A3',
    'C6F8': 'C0A4',
    'C6F9': 'C0A5',
    'C6FD': 'C0A6',
    'C704': 'C0A7',
    'C705': 'C0A8',
    'C708': 'C0A9',
    'C70C': 'C0AA',
    'C714': 'C0AB',
    'C715': 'C0AC',
    'C717': 'C0AD',
    'C719': 'C0AE',
    'C720': 'C0AF',
    'C721': 'C0B0',
    'C724': 'C0B1',
    'C728': 'C0B2',
    'C730': 'C0B3',
    'C731': 'C0B4',
    'C733': 'C0B5',
    'C735': 'C0B6',
    'C737': 'C0B7',
    'C73C': 'C0B8',
    'C73D': 'C0B9',
    'C740': 'C0BA',
    'C744': 'C0BB',
    'C74A': 'C0BC',
    'C74C': 'C0BD',
    'C74D': 'C0BE',
    'C74F': 'C0BF',
    'C751': 'C0C0',
    'C752': 'C0C1',
    'C753': 'C0C2',
    'C754': 'C0C3',
    'C755': 'C0C4',
    'C756': 'C0C5',
    'C757': 'C0C6',
    'C758': 'C0C7',
    'C75C': 'C0C8',
    'C760': 'C0C9',
    'C768': 'C0CA',
    'C76B': 'C0CB',
    'C774': 'C0CC',
    'C775': 'C0CD',
    'C778': 'C0CE',
    'C77C': 'C0CF',
    'C77D': 'C0D0',
    'C77E': 'C0D1',
    'C783': 'C0D2',
    'C784': 'C0D3',
    'C785': 'C0D4',
    'C787': 'C0D5',
    'C788': 'C0D6',
    'C789': 'C0D7',
    'C78A': 'C0D8',
    'C78E': 'C0D9',
    'C790': 'C0DA',
    'C791': 'C0DB',
    'C794': 'C0DC',
    'C796': 'C0DD',
    'C797': 'C0DE',
    'C798': 'C0DF',
    'C79A': 'C0E0',
    'C7A0': 'C0E1',
    'C7A1': 'C0E2',
    'C7A3': 'C0E3',
    'C7A4': 'C0E4',
    'C7A5': 'C0E5',
    'C7A6': 'C0E6',
    'C7AC': 'C0E7',
    'C7AD': 'C0E8',
    'C7B0': 'C0E9',
    'C7B4': 'C0EA',
    'C7BC': 'C0EB',
    'C7BD': 'C0EC',
    'C7BF': 'C0ED',
    'C7C0': 'C0EE',
    'C7C1': 'C0EF',
    'C7C8': 'C0F0',
    'C7C9': 'C0F1',
    'C7CC': 'C0F2',
    'C7CE': 'C0F3',
    'C7D0': 'C0F4',
    'C7D8': 'C0F5',
    'C7DD': 'C0F6',
    'C7E4': 'C0F7',
    'C7E8': 'C0F8',
    'C7EC': 'C0F9',
    'C800': 'C0FA',
    'C801': 'C0FB',
    'C804': 'C0FC',
    'C808': 'C0FD',
    'C80A': 'C0FE',
    'C810': 'C1A1',
    'C811': 'C1A2',
    'C813': 'C1A3',
    'C815': 'C1A4',
    'C816': 'C1A5',
    'C81C': 'C1A6',
    'C81D': 'C1A7',
    'C820': 'C1A8',
    'C824': 'C1A9',
    'C82C': 'C1AA',
    'C82D': 'C1AB',
    'C82F': 'C1AC',
    'C831': 'C1AD',
    'C838': 'C1AE',
    'C83C': 'C1AF',
    'C840': 'C1B0',
    'C848': 'C1B1',
    'C849': 'C1B2',
    'C84C': 'C1B3',
    'C84D': 'C1B4',
    'C854': 'C1B5',
    'C870': 'C1B6',
    'C871': 'C1B7',
    'C874': 'C1B8',
    'C878': 'C1B9',
    'C87A': 'C1BA',
    'C880': 'C1BB',
    'C881': 'C1BC',
    'C883': 'C1BD',
    'C885': 'C1BE',
    'C886': 'C1BF',
    'C887': 'C1C0',
    'C88B': 'C1C1',
    'C88C': 'C1C2',
    'C88D': 'C1C3',
    'C894': 'C1C4',
    'C89D': 'C1C5',
    'C89F': 'C1C6',
    'C8A1': 'C1C7',
    'C8A8': 'C1C8',
    'C8BC': 'C1C9',
    'C8BD': 'C1CA',
    'C8C4': 'C1CB',
    'C8C8': 'C1CC',
    'C8CC': 'C1CD',
    'C8D4': 'C1CE',
    'C8D5': 'C1CF',
    'C8D7': 'C1D0',
    'C8D9': 'C1D1',
    'C8E0': 'C1D2',
    'C8E1': 'C1D3',
    'C8E4': 'C1D4',
    'C8F5': 'C1D5',
    'C8FC': 'C1D6',
    'C8FD': 'C1D7',
    'C900': 'C1D8',
    'C904': 'C1D9',
    'C905': 'C1DA',
    'C906': 'C1DB',
    'C90C': 'C1DC',
    'C90D': 'C1DD',
    'C90F': 'C1DE',
    'C911': 'C1DF',
    'C918': 'C1E0',
    'C92C': 'C1E1',
    'C934': 'C1E2',
    'C950': 'C1E3',
    'C951': 'C1E4',
    'C954': 'C1E5',
    'C958': 'C1E6',
    'C960': 'C1E7',
    'C961': 'C1E8',
    'C963': 'C1E9',
    'C96C': 'C1EA',
    'C970': 'C1EB',
    'C974': 'C1EC',
    'C97C': 'C1ED',
    'C988': 'C1EE',
    'C989': 'C1EF',
    'C98C': 'C1F0',
    'C990': 'C1F1',
    'C998': 'C1F2',
    'C999': 'C1F3',
    'C99B': 'C1F4',
    'C99D': 'C1F5',
    'C9C0': 'C1F6',
    'C9C1': 'C1F7',
    'C9C4': 'C1F8',
    'C9C7': 'C1F9',
    'C9C8': 'C1FA',
    'C9CA': 'C1FB',
    'C9D0': 'C1FC',
    'C9D1': 'C1FD',
    'C9D3': 'C1FE',
    'C9D5': 'C2A1',
    'C9D6': 'C2A2',
    'C9D9': 'C2A3',
    'C9DA': 'C2A4',
    'C9DC': 'C2A5',
    'C9DD': 'C2A6',
    'C9E0': 'C2A7',
    'C9E2': 'C2A8',
    'C9E4': 'C2A9',
    'C9E7': 'C2AA',
    'C9EC': 'C2AB',
    'C9ED': 'C2AC',
    'C9EF': 'C2AD',
    'C9F0': 'C2AE',
    'C9F1': 'C2AF',
    'C9F8': 'C2B0',
    'C9F9': 'C2B1',
    'C9FC': 'C2B2',
    'CA00': 'C2B3',
    'CA08': 'C2B4',
    'CA09': 'C2B5',
    'CA0B': 'C2B6',
    'CA0C': 'C2B7',
    'CA0D': 'C2B8',
    'CA14': 'C2B9',
    'CA18': 'C2BA',
    'CA29': 'C2BB',
    'CA4C': 'C2BC',
    'CA4D': 'C2BD',
    'CA50': 'C2BE',
    'CA54': 'C2BF',
    'CA5C': 'C2C0',
    'CA5D': 'C2C1',
    'CA5F': 'C2C2',
    'CA60': 'C2C3',
    'CA61': 'C2C4',
    'CA68': 'C2C5',
    'CA7D': 'C2C6',
    'CA84': 'C2C7',
    'CA98': 'C2C8',
    'CABC': 'C2C9',
    'CABD': 'C2CA',
    'CAC0': 'C2CB',
    'CAC4': 'C2CC',
    'CACC': 'C2CD',
    'CACD': 'C2CE',
    'CACF': 'C2CF',
    'CAD1': 'C2D0',
    'CAD3': 'C2D1',
    'CAD8': 'C2D2',
    'CAD9': 'C2D3',
    'CAE0': 'C2D4',
    'CAEC': 'C2D5',
    'CAF4': 'C2D6',
    'CB08': 'C2D7',
    'CB10': 'C2D8',
    'CB14': 'C2D9',
    'CB18': 'C2DA',
    'CB20': 'C2DB',
    'CB21': 'C2DC',
    'CB41': 'C2DD',
    'CB48': 'C2DE',
    'CB49': 'C2DF',
    'CB4C': 'C2E0',
    'CB50': 'C2E1',
    'CB58': 'C2E2',
    'CB59': 'C2E3',
    'CB5D': 'C2E4',
    'CB64': 'C2E5',
    'CB78': 'C2E6',
    'CB79': 'C2E7',
    'CB9C': 'C2E8',
    'CBB8': 'C2E9',
    'CBD4': 'C2EA',
    'CBE4': 'C2EB',
    'CBE7': 'C2EC',
    'CBE9': 'C2ED',
    'CC0C': 'C2EE',
    'CC0D': 'C2EF',
    'CC10': 'C2F0',
    'CC14': 'C2F1',
    'CC1C': 'C2F2',
    'CC1D': 'C2F3',
    'CC21': 'C2F4',
    'CC22': 'C2F5',
    'CC27': 'C2F6',
    'CC28': 'C2F7',
    'CC29': 'C2F8',
    'CC2C': 'C2F9',
    'CC2E': 'C2FA',
    'CC30': 'C2FB',
    'CC38': 'C2FC',
    'CC39': 'C2FD',
    'CC3B': 'C2FE',
    'CC3C': 'C3A1',
    'CC3D': 'C3A2',
    'CC3E': 'C3A3',
    'CC44': 'C3A4',
    'CC45': 'C3A5',
    'CC48': 'C3A6',
    'CC4C': 'C3A7',
    'CC54': 'C3A8',
    'CC55': 'C3A9',
    'CC57': 'C3AA',
    'CC58': 'C3AB',
    'CC59': 'C3AC',
    'CC60': 'C3AD',
    'CC64': 'C3AE',
    'CC66': 'C3AF',
    'CC68': 'C3B0',
    'CC70': 'C3B1',
    'CC75': 'C3B2',
    'CC98': 'C3B3',
    'CC99': 'C3B4',
    'CC9C': 'C3B5',
    'CCA0': 'C3B6',
    'CCA8': 'C3B7',
    'CCA9': 'C3B8',
    'CCAB': 'C3B9',
    'CCAC': 'C3BA',
    'CCAD': 'C3BB',
    'CCB4': 'C3BC',
    'CCB5': 'C3BD',
    'CCB8': 'C3BE',
    'CCBC': 'C3BF',
    'CCC4': 'C3C0',
    'CCC5': 'C3C1',
    'CCC7': 'C3C2',
    'CCC9': 'C3C3',
    'CCD0': 'C3C4',
    'CCD4': 'C3C5',
    'CCE4': 'C3C6',
    'CCEC': 'C3C7',
    'CCF0': 'C3C8',
    'CD01': 'C3C9',
    'CD08': 'C3CA',
    'CD09': 'C3CB',
    'CD0C': 'C3CC',
    'CD10': 'C3CD',
    'CD18': 'C3CE',
    'CD19': 'C3CF',
    'CD1B': 'C3D0',
    'CD1D': 'C3D1',
    'CD24': 'C3D2',
    'CD28': 'C3D3',
    'CD2C': 'C3D4',
    'CD39': 'C3D5',
    'CD5C': 'C3D6',
    'CD60': 'C3D7',
    'CD64': 'C3D8',
    'CD6C': 'C3D9',
    'CD6D': 'C3DA',
    'CD6F': 'C3DB',
    'CD71': 'C3DC',
    'CD78': 'C3DD',
    'CD88': 'C3DE',
    'CD94': 'C3DF',
    'CD95': 'C3E0',
    'CD98': 'C3E1',
    'CD9C': 'C3E2',
    'CDA4': 'C3E3',
    'CDA5': 'C3E4',
    'CDA7': 'C3E5',
    'CDA9': 'C3E6',
    'CDB0': 'C3E7',
    'CDC4': 'C3E8',
    'CDCC': 'C3E9',
    'CDD0': 'C3EA',
    'CDE8': 'C3EB',
    'CDEC': 'C3EC',
    'CDF0': 'C3ED',
    'CDF8': 'C3EE',
    'CDF9': 'C3EF',
    'CDFB': 'C3F0',
    'CDFD': 'C3F1',
    'CE04': 'C3F2',
    'CE08': 'C3F3',
    'CE0C': 'C3F4',
    'CE14': 'C3F5',
    'CE19': 'C3F6',
    'CE20': 'C3F7',
    'CE21': 'C3F8',
    'CE24': 'C3F9',
    'CE28': 'C3FA',
    'CE30': 'C3FB',
    'CE31': 'C3FC',
    'CE33': 'C3FD',
    'CE35': 'C3FE',
    'CE58': 'C4A1',
    'CE59': 'C4A2',
    'CE5C': 'C4A3',
    'CE5F': 'C4A4',
    'CE60': 'C4A5',
    'CE61': 'C4A6',
    'CE68': 'C4A7',
    'CE69': 'C4A8',
    'CE6B': 'C4A9',
    'CE6D': 'C4AA',
    'CE74': 'C4AB',
    'CE75': 'C4AC',
    'CE78': 'C4AD',
    'CE7C': 'C4AE',
    'CE84': 'C4AF',
    'CE85': 'C4B0',
    'CE87': 'C4B1',
    'CE89': 'C4B2',
    'CE90': 'C4B3',
    'CE91': 'C4B4',
    'CE94': 'C4B5',
    'CE98': 'C4B6',
    'CEA0': 'C4B7',
    'CEA1': 'C4B8',
    'CEA3': 'C4B9',
    'CEA4': 'C4BA',
    'CEA5': 'C4BB',
    'CEAC': 'C4BC',
    'CEAD': 'C4BD',
    'CEC1': 'C4BE',
    'CEE4': 'C4BF',
    'CEE5': 'C4C0',
    'CEE8': 'C4C1',
    'CEEB': 'C4C2',
    'CEEC': 'C4C3',
    'CEF4': 'C4C4',
    'CEF5': 'C4C5',
    'CEF7': 'C4C6',
    'CEF8': 'C4C7',
    'CEF9': 'C4C8',
    'CF00': 'C4C9',
    'CF01': 'C4CA',
    'CF04': 'C4CB',
    'CF08': 'C4CC',
    'CF10': 'C4CD',
    'CF11': 'C4CE',
    'CF13': 'C4CF',
    'CF15': 'C4D0',
    'CF1C': 'C4D1',
    'CF20': 'C4D2',
    'CF24': 'C4D3',
    'CF2C': 'C4D4',
    'CF2D': 'C4D5',
    'CF2F': 'C4D6',
    'CF30': 'C4D7',
    'CF31': 'C4D8',
    'CF38': 'C4D9',
    'CF54': 'C4DA',
    'CF55': 'C4DB',
    'CF58': 'C4DC',
    'CF5C': 'C4DD',
    'CF64': 'C4DE',
    'CF65': 'C4DF',
    'CF67': 'C4E0',
    'CF69': 'C4E1',
    'CF70': 'C4E2',
    'CF71': 'C4E3',
    'CF74': 'C4E4',
    'CF78': 'C4E5',
    'CF80': 'C4E6',
    'CF85': 'C4E7',
    'CF8C': 'C4E8',
    'CFA1': 'C4E9',
    'CFA8': 'C4EA',
    'CFB0': 'C4EB',
    'CFC4': 'C4EC',
    'CFE0': 'C4ED',
    'CFE1': 'C4EE',
    'CFE4': 'C4EF',
    'CFE8': 'C4F0',
    'CFF0': 'C4F1',
    'CFF1': 'C4F2',
    'CFF3': 'C4F3',
    'CFF5': 'C4F4',
    'CFFC': 'C4F5',
    'D000': 'C4F6',
    'D004': 'C4F7',
    'D011': 'C4F8',
    'D018': 'C4F9',
    'D02D': 'C4FA',
    'D034': 'C4FB',
    'D035': 'C4FC',
    'D038': 'C4FD',
    'D03C': 'C4FE',
    'D044': 'C5A1',
    'D045': 'C5A2',
    'D047': 'C5A3',
    'D049': 'C5A4',
    'D050': 'C5A5',
    'D054': 'C5A6',
    'D058': 'C5A7',
    'D060': 'C5A8',
    'D06C': 'C5A9',
    'D06D': 'C5AA',
    'D070': 'C5AB',
    'D074': 'C5AC',
    'D07C': 'C5AD',
    'D07D': 'C5AE',
    'D081': 'C5AF',
    'D0A4': 'C5B0',
    'D0A5': 'C5B1',
    'D0A8': 'C5B2',
    'D0AC': 'C5B3',
    'D0B4': 'C5B4',
    'D0B5': 'C5B5',
    'D0B7': 'C5B6',
    'D0B9': 'C5B7',
    'D0C0': 'C5B8',
    'D0C1': 'C5B9',
    'D0C4': 'C5BA',
    'D0C8': 'C5BB',
    'D0C9': 'C5BC',
    'D0D0': 'C5BD',
    'D0D1': 'C5BE',
    'D0D3': 'C5BF',
    'D0D4': 'C5C0',
    'D0D5': 'C5C1',
    'D0DC': 'C5C2',
    'D0DD': 'C5C3',
    'D0E0': 'C5C4',
    'D0E4': 'C5C5',
    'D0EC': 'C5C6',
    'D0ED': 'C5C7',
    'D0EF': 'C5C8',
    'D0F0': 'C5C9',
    'D0F1': 'C5CA',
    'D0F8': 'C5CB',
    'D10D': 'C5CC',
    'D130': 'C5CD',
    'D131': 'C5CE',
    'D134': 'C5CF',
    'D138': 'C5D0',
    'D13A': 'C5D1',
    'D140': 'C5D2',
    'D141': 'C5D3',
    'D143': 'C5D4',
    'D144': 'C5D5',
    'D145': 'C5D6',
    'D14C': 'C5D7',
    'D14D': 'C5D8',
    'D150': 'C5D9',
    'D154': 'C5DA',
    'D15C': 'C5DB',
    'D15D': 'C5DC',
    'D15F': 'C5DD',
    'D161': 'C5DE',
    'D168': 'C5DF',
    'D16C': 'C5E0',
    'D17C': 'C5E1',
    'D184': 'C5E2',
    'D188': 'C5E3',
    'D1A0': 'C5E4',
    'D1A1': 'C5E5',
    'D1A4': 'C5E6',
    'D1A8': 'C5E7',
    'D1B0': 'C5E8',
    'D1B1': 'C5E9',
    'D1B3': 'C5EA',
    'D1B5': 'C5EB',
    'D1BA': 'C5EC',
    'D1BC': 'C5ED',
    'D1C0': 'C5EE',
    'D1D8': 'C5EF',
    'D1F4': 'C5F0',
    'D1F8': 'C5F1',
    'D207': 'C5F2',
    'D209': 'C5F3',
    'D210': 'C5F4',
    'D22C': 'C5F5',
    'D22D': 'C5F6',
    'D230': 'C5F7',
    'D234': 'C5F8',
    'D23C': 'C5F9',
    'D23D': 'C5FA',
    'D23F': 'C5FB',
    'D241': 'C5FC',
    'D248': 'C5FD',
    'D25C': 'C5FE',
    'D264': 'C6A1',
    'D280': 'C6A2',
    'D281': 'C6A3',
    'D284': 'C6A4',
    'D288': 'C6A5',
    'D290': 'C6A6',
    'D291': 'C6A7',
    'D295': 'C6A8',
    'D29C': 'C6A9',
    'D2A0': 'C6AA',
    'D2A4': 'C6AB',
    'D2AC': 'C6AC',
    'D2B1': 'C6AD',
    'D2B8': 'C6AE',
    'D2B9': 'C6AF',
    'D2BC': 'C6B0',
    'D2BF': 'C6B1',
    'D2C0': 'C6B2',
    'D2C2': 'C6B3',
    'D2C8': 'C6B4',
    'D2C9': 'C6B5',
    'D2CB': 'C6B6',
    'D2D4': 'C6B7',
    'D2D8': 'C6B8',
    'D2DC': 'C6B9',
    'D2E4': 'C6BA',
    'D2E5': 'C6BB',
    'D2F0': 'C6BC',
    'D2F1': 'C6BD',
    'D2F4': 'C6BE',
    'D2F8': 'C6BF',
    'D300': 'C6C0',
    'D301': 'C6C1',
    'D303': 'C6C2',
    'D305': 'C6C3',
    'D30C': 'C6C4',
    'D30D': 'C6C5',
    'D30E': 'C6C6',
    'D310': 'C6C7',
    'D314': 'C6C8',
    'D316': 'C6C9',
    'D31C': 'C6CA',
    'D31D': 'C6CB',
    'D31F': 'C6CC',
    'D320': 'C6CD',
    'D321': 'C6CE',
    'D325': 'C6CF',
    'D328': 'C6D0',
    'D329': 'C6D1',
    'D32C': 'C6D2',
    'D330': 'C6D3',
    'D338': 'C6D4',
    'D339': 'C6D5',
    'D33B': 'C6D6',
    'D33C': 'C6D7',
    'D33D': 'C6D8',
    'D344': 'C6D9',
    'D345': 'C6DA',
    'D37C': 'C6DB',
    'D37D': 'C6DC',
    'D380': 'C6DD',
    'D384': 'C6DE',
    'D38C': 'C6DF',
    'D38D': 'C6E0',
    'D38F': 'C6E1',
    'D390': 'C6E2',
    'D391': 'C6E3',
    'D398': 'C6E4',
    'D399': 'C6E5',
    'D39C': 'C6E6',
    'D3A0': 'C6E7',
    'D3A8': 'C6E8',
    'D3A9': 'C6E9',
    'D3AB': 'C6EA',
    'D3AD': 'C6EB',
    'D3B4': 'C6EC',
    'D3B8': 'C6ED',
    'D3BC': 'C6EE',
    'D3C4': 'C6EF',
    'D3C5': 'C6F0',
    'D3C8': 'C6F1',
    'D3C9': 'C6F2',
    'D3D0': 'C6F3',
    'D3D8': 'C6F4',
    'D3E1': 'C6F5',
    'D3E3': 'C6F6',
    'D3EC': 'C6F7',
    'D3ED': 'C6F8',
    'D3F0': 'C6F9',
    'D3F4': 'C6FA',
    'D3FC': 'C6FB',
    'D3FD': 'C6FC',
    'D3FF': 'C6FD',
    'D401': 'C6FE',
    'D408': 'C7A1',
    'D41D': 'C7A2',
    'D440': 'C7A3',
    'D444': 'C7A4',
    'D45C': 'C7A5',
    'D460': 'C7A6',
    'D464': 'C7A7',
    'D46D': 'C7A8',
    'D46F': 'C7A9',
    'D478': 'C7AA',
    'D479': 'C7AB',
    'D47C': 'C7AC',
    'D47F': 'C7AD',
    'D480': 'C7AE',
    'D482': 'C7AF',
    'D488': 'C7B0',
    'D489': 'C7B1',
    'D48B': 'C7B2',
    'D48D': 'C7B3',
    'D494': 'C7B4',
    'D4A9': 'C7B5',
    'D4CC': 'C7B6',
    'D4D0': 'C7B7',
    'D4D4': 'C7B8',
    'D4DC': 'C7B9',
    'D4DF': 'C7BA',
    'D4E8': 'C7BB',
    'D4EC': 'C7BC',
    'D4F0': 'C7BD',
    'D4F8': 'C7BE',
    'D4FB': 'C7BF',
    'D4FD': 'C7C0',
    'D504': 'C7C1',
    'D508': 'C7C2',
    'D50C': 'C7C3',
    'D514': 'C7C4',
    'D515': 'C7C5',
    'D517': 'C7C6',
    'D53C': 'C7C7',
    'D53D': 'C7C8',
    'D540': 'C7C9',
    'D544': 'C7CA',
    'D54C': 'C7CB',
    'D54D': 'C7CC',
    'D54F': 'C7CD',
    'D551': 'C7CE',
    'D558': 'C7CF',
    'D559': 'C7D0',
    'D55C': 'C7D1',
    'D560': 'C7D2',
    'D565': 'C7D3',
    'D568': 'C7D4',
    'D569': 'C7D5',
    'D56B': 'C7D6',
    'D56D': 'C7D7',
    'D574': 'C7D8',
    'D575': 'C7D9',
    'D578': 'C7DA',
    'D57C': 'C7DB',
    'D584': 'C7DC',
    'D585': 'C7DD',
    'D587': 'C7DE',
    'D588': 'C7DF',
    'D589': 'C7E0',
    'D590': 'C7E1',
    'D5A5': 'C7E2',
    'D5C8': 'C7E3',
    'D5C9': 'C7E4',
    'D5CC': 'C7E5',
    'D5D0': 'C7E6',
    'D5D2': 'C7E7',
    'D5D8': 'C7E8',
    'D5D9': 'C7E9',
    'D5DB': 'C7EA',
    'D5DD': 'C7EB',
    'D5E4': 'C7EC',
    'D5E5': 'C7ED',
    'D5E8': 'C7EE',
    'D5EC': 'C7EF',
    'D5F4': 'C7F0',
    'D5F5': 'C7F1',
    'D5F7': 'C7F2',
    'D5F9': 'C7F3',
    'D600': 'C7F4',
    'D601': 'C7F5',
    'D604': 'C7F6',
    'D608': 'C7F7',
    'D610': 'C7F8',
    'D611': 'C7F9',
    'D613': 'C7FA',
    'D614': 'C7FB',
    'D615': 'C7FC',
    'D61C': 'C7FD',
    'D620': 'C7FE',
    'D624': 'C8A1',
    'D62D': 'C8A2',
    'D638': 'C8A3',
    'D639': 'C8A4',
    'D63C': 'C8A5',
    'D640': 'C8A6',
    'D645': 'C8A7',
    'D648': 'C8A8',
    'D649': 'C8A9',
    'D64B': 'C8AA',
    'D64D': 'C8AB',
    'D651': 'C8AC',
    'D654': 'C8AD',
    'D655': 'C8AE',
    'D658': 'C8AF',
    'D65C': 'C8B0',
    'D667': 'C8B1',
    'D669': 'C8B2',
    'D670': 'C8B3',
    'D671': 'C8B4',
    'D674': 'C8B5',
    'D683': 'C8B6',
    'D685': 'C8B7',
    'D68C': 'C8B8',
    'D68D': 'C8B9',
    'D690': 'C8BA',
    'D694': 'C8BB',
    'D69D': 'C8BC',
    'D69F': 'C8BD',
    'D6A1': 'C8BE',
    'D6A8': 'C8BF',
    'D6AC': 'C8C0',
    'D6B0': 'C8C1',
    'D6B9': 'C8C2',
    'D6BB': 'C8C3',
    'D6C4': 'C8C4',
    'D6C5': 'C8C5',
    'D6C8': 'C8C6',
    'D6CC': 'C8C7',
    'D6D1': 'C8C8',
    'D6D4': 'C8C9',
    'D6D7': 'C8CA',
    'D6D9': 'C8CB',
    'D6E0': 'C8CC',
    'D6E4': 'C8CD',
    'D6E8': 'C8CE',
    'D6F0': 'C8CF',
    'D6F5': 'C8D0',
    'D6FC': 'C8D1',
    'D6FD': 'C8D2',
    'D700': 'C8D3',
    'D704': 'C8D4',
    'D711': 'C8D5',
    'D718': 'C8D6',
    'D719': 'C8D7',
    'D71C': 'C8D8',
    'D720': 'C8D9',
    'D728': 'C8DA',
    'D729': 'C8DB',
    'D72B': 'C8DC',
    'D72D': 'C8DD',
    'D734': 'C8DE',
    'D735': 'C8DF',
    'D738': 'C8E0',
    'D73C': 'C8E1',
    'D744': 'C8E2',
    'D747': 'C8E3',
    'D749': 'C8E4',
    'D750': 'C8E5',
    'D751': 'C8E6',
    'D754': 'C8E7',
    'D756': 'C8E8',
    'D757': 'C8E9',
    'D758': 'C8EA',
    'D759': 'C8EB',
    'D760': 'C8EC',
    'D761': 'C8ED',
    'D763': 'C8EE',
    'D765': 'C8EF',
    'D769': 'C8F0',
    'D76C': 'C8F1',
    'D770': 'C8F2',
    'D774': 'C8F3',
    'D77C': 'C8F4',
    'D77D': 'C8F5',
    'D781': 'C8F6',
    'D788': 'C8F7',
    'D789': 'C8F8',
    'D78C': 'C8F9',
    'D790': 'C8FA',
    'D798': 'C8FB',
    'D799': 'C8FC',
    'D79B': 'C8FD',
    'D79D': 'C8FE',
};